include:
  - template: Code-Quality.gitlab-ci.yml

stages:
    - clone
    - build
    - test

clone:
    image:
        name: alpine/git:latest
        entrypoint: [""]
    stage: clone
    script:
        - git clone https://gitlab.com/hctulip/torasu/core/torasu-java runner/torasu-java
        - git clone https://gitlab.com/hctulip/torasu/std/torasu-java-std runner/torasu-java-std
        - mkdir -p artifacts
    artifacts:
        paths:
            - runner
            - artifacts
        expire_in: 1 week
    
torasu-java:
    image:
        name: gradle:latest
        entrypoint: [""]
    stage: build
    script:
        - (cd $PWD'/runner/torasu-java' && ./gradlew jar)
        - mv runner/torasu-java/build/libs/torasu-java.jar artifacts/torasu-java-lite.jar
    artifacts:
        paths:
            - artifacts/
        expire_in: 4 weeks

torasu-java-std:
    image:
        name: gradle:latest
        entrypoint: [""]
    stage: build
    script:
        - (cd $PWD'/runner/torasu-java-std' && ./gradlew shadowJar)
        - mv runner/torasu-java-std/build/libs/torasu-java-full.jar artifacts/torasu-java.jar
    artifacts:
        paths:
            - artifacts/
        expire_in: 4 weeks

code_quality:
    image: docker:stable
    variables:
        DOCKER_DRIVER: overlay2
    allow_failure: true
    services:
        - docker:stable-dind
    script:
        - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
        - docker run
            --env SOURCE_CODE="$PWD"
            --volume "$PWD":/code
            --volume /var/run/docker.sock:/var/run/docker.sock
            "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
    artifacts:
        reports:
            codequality: gl-code-quality-report.json
